registerInputEvent(fxDtsBrick,"onVehicleTouch","Self fxDtsBrick\tDriverPlayer Player\tDriverClient GameConnection\tVehicle Vehicle\tMinigame Minigame");
$onVehicleTouch::eventIndex = inputEvent_GetInputEventIdx("onVehicleTouch");
datablock TriggerData(VehicleTouchTriggerData)
{
	tickPeriodMS = 250;
};
function VehicleTouchTriggerData::onEnterTrigger(%this,%trigger,%user)
{
	if(%user.dataBlock.category !$= "Vehicles" || !isObject(%trigger.vehicleSet) || !isObject(%trigger.spawnBrick))
	{
		return;
	}
	%trigger.vehicleSet.add(%user);
}
function VehicleTouchTriggerData::onLeaveTrigger(%this,%trigger,%user)
{
	if(%user.dataBlock.category !$= "Vehicles" || !isObject(%trigger.vehicleSet) || !isObject(%trigger.spawnBrick))
	{
		return;
	}
	%trigger.vehicleSet.remove(%user);
}
function VehicleTouchTriggerData::onTickTrigger(%this,%trigger)
{
	if(!isObject(%trigger.vehicleSet) || !isObject(%trigger.spawnBrick) || %trigger.vehicleSet.getCount() < 1)
	{
		return;
	}
	%user = %trigger.vehicleSet.getObject(0);
	if(!isObject(%user) || !%trigger.spawnBrick.isColliding())
	{
		return;
	}
	%player = %user.getMountedObject(0);
	%client = %player.client;
	$inputTarget_Self = %trigger.spawnBrick;
	$inputTarget_DriverPlayer = %player;
	$inputTarget_DriverClient = %client;
	$inputTarget_Vehicle = %user;
	$inputTarget_Minigame = getMinigameFromObject(%client);
	%trigger.spawnBrick.processInputEvent("onVehicleTouch",%client);
}
package Event_onVehicleTouch
{
	function serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4)
	{
		if(%input == $onVehicleTouch::eventIndex && isObject(%client.wrenchBrick) && !isObject(%client.wrenchBrick.vehicleTouchDetector))
		{
			%t = new Trigger()
			{
				dataBlock = VehicleTouchTriggerData;
				polyhedron = "0 0 0 1 0 0 0 -1 0 0 0 1";
			};
			missionCleanup.add(%t);
			%boxMin = getWords(%client.wrenchBrick.getWorldBox(),0,2);
			%boxMax = getWords(%client.wrenchBrick.getWorldBox(),3,5);
			%boxDiff = vectorSub(%boxMax,%boxMin);
			%boxDiff = vectorAdd(%boxDiff,"0 0 0.2"); 
			%t.setScale(%boxDiff);
			%posA = %client.wrenchBrick.getWorldBoxCenter();
			%posB = %t.getWorldBoxCenter();
			%posDiff = vectorSub(%posA,%posB);
			%posDiff = vectorAdd(%posDiff,"0 0 0.1");
			%t.setTransform(%posDiff);
			%client.wrenchBrick.vehicleTouchDetector = %t;
			%t.spawnBrick = %client.wrenchBrick;
			%t.vehicleSet = new SimSet();
		}
		return Parent::serverCmdAddEvent(%client,%delay,%input,%target,%a,%b,%output,%para1,%para2,%para3,%para4);
	}
	function serverCmdClearEvents(%client)
	{
		if(isObject(%client.wrenchBrick.vehicleTouchDetector))
		{
			if(isObject(%client.wrenchBrick.vehicleTouchDetector.vehicleSet))
			{
				%client.wrenchBrick.vehicleTouchDetector.vehicleSet.delete();
			}
			%client.wrenchBrick.vehicleTouchDetector.delete();
		}
		Parent::serverCmdClearEvents(%client);
	}
	function fxDtsBrick::onDeath(%brick)
	{
		if(isObject(%brick.vehicleTouchDetector))
		{
			if(isObject(%client.wrenchBrick.vehicleTouchDetector.vehicleSet))
			{
				%client.wrenchBrick.vehicleTouchDetector.vehicleSet.delete();
			}
			%brick.vehicleTouchDetector.delete();
		}
		Parent::onDeath(%brick);
	}
};
activatePackage(Event_onVehicleTouch);